diff -rNci gcc-2.7.2/flow.c gcc-2.7.2p/flow.c
*** gcc-2.7.2/flow.c	Mon Aug 28 10:23:34 1995
--- gcc-2.7.2p/flow.c	Tue Jan 23 09:35:24 1996
***************
*** 286,299 ****
  static HARD_REG_SET elim_reg_set;
  
  /* Forward declarations */
! static void find_basic_blocks		PROTO((rtx, rtx));
  static int uses_reg_or_mem		PROTO((rtx));
  static void mark_label_ref		PROTO((rtx, rtx, int));
! static void life_analysis		PROTO((rtx, int));
  void allocate_for_life_analysis		PROTO((void));
! static void init_regset_vector		PROTO((regset *, regset, int, int));
  static void propagate_block		PROTO((regset, rtx, rtx, int, 
! 					       regset, int));
  static rtx flow_delete_insn		PROTO((rtx));
  static int insn_dead_p			PROTO((rtx, regset, int));
  static int libcall_dead_p		PROTO((rtx, regset, rtx, rtx));
--- 286,299 ----
  static HARD_REG_SET elim_reg_set;
  
  /* Forward declarations */
! static void find_basic_blocks		PROTO((rtx, rtx, int));
  static int uses_reg_or_mem		PROTO((rtx));
  static void mark_label_ref		PROTO((rtx, rtx, int));
! static void life_analysis		PROTO((rtx, int, int));
  void allocate_for_life_analysis		PROTO((void));
! /* intel2 static */ void init_regset_vector		PROTO((regset *, regset, int, int));
  static void propagate_block		PROTO((regset, rtx, rtx, int, 
! 					       regset, int, int));
  static rtx flow_delete_insn		PROTO((rtx));
  static int insn_dead_p			PROTO((rtx, regset, int));
  static int libcall_dead_p		PROTO((rtx, regset, rtx, rtx));
***************
*** 307,322 ****
--- 307,333 ----
  static int try_pre_increment		PROTO((rtx, rtx, HOST_WIDE_INT));
  static rtx find_use_as_address		PROTO((rtx, rtx, HOST_WIDE_INT));
  void dump_flow_info			PROTO((FILE *));
+ /* intel1 */
+ static void correct_cse_mistakes ();
+ static void count_reg_uses ();
+ static void do_correction ();
  
  /* Find basic blocks of the current function and perform data flow analysis.
     F is the first insn of the function and NREGS the number of register numbers
     in use.  */
  
  void
+ /*
  flow_analysis (f, nregs, file)
+ */
+ /* intel2 - added the change_f flag to disable changes to the insns, when called
+  * by memory_simplify. Don't apply any change to an insn if this flag == 0
+  */
+ flow_analysis (f, nregs, file, change_f)
       rtx f;
       int nregs;
       FILE *file;
+ 	 int change_f; /* intel2 */
  {
    register rtx insn;
    register int i;
***************
*** 326,331 ****
--- 337,350 ----
    static struct {int from, to; } eliminables[] = ELIMINABLE_REGS;
  #endif
  
+   /* intel1 */
+ #ifdef SPARE_REGS
+   if (change_f && flag_opt_reg_stack)
+     {
+       nregs += SPARE_REGS;
+     }
+ #endif
+ 
    /* Record which registers will be eliminated.  We use this in
       mark_used_regs. */
  
***************
*** 372,380 ****
    /* Allocate some tables that last till end of compiling this function
       and some needed only in find_basic_blocks and life_analysis.  */
  
!   n_basic_blocks = i;
!   basic_block_head = (rtx *) oballoc (n_basic_blocks * sizeof (rtx));
!   basic_block_end = (rtx *) oballoc (n_basic_blocks * sizeof (rtx));
    basic_block_drops_in = (char *) alloca (n_basic_blocks);
    basic_block_loop_depth = (short *) alloca (n_basic_blocks * sizeof (short));
    uid_block_number
--- 391,403 ----
    /* Allocate some tables that last till end of compiling this function
       and some needed only in find_basic_blocks and life_analysis.  */
  
!   if (change_f || (n_basic_blocks!=i)) 
!   /* intel2 if change_f is 0 we may have already allocated basic blocks */
!     {
!       n_basic_blocks = i;
!       basic_block_head = (rtx *) oballoc (n_basic_blocks * sizeof (rtx));
!       basic_block_end = (rtx *) oballoc (n_basic_blocks * sizeof (rtx));
!     }
    basic_block_drops_in = (char *) alloca (n_basic_blocks);
    basic_block_loop_depth = (short *) alloca (n_basic_blocks * sizeof (short));
    uid_block_number
***************
*** 382,392 ****
    uid_volatile = (char *) alloca (max_uid_for_flow + 1);
    bzero (uid_volatile, max_uid_for_flow + 1);
  
!   find_basic_blocks (f, nonlocal_label_list);
!   life_analysis (f, nregs);
    if (file)
      dump_flow_info (file);
  
    basic_block_drops_in = 0;
    uid_block_number = 0;
    basic_block_loop_depth = 0;
--- 405,420 ----
    uid_volatile = (char *) alloca (max_uid_for_flow + 1);
    bzero (uid_volatile, max_uid_for_flow + 1);
  
!   find_basic_blocks (f, nonlocal_label_list /* intel2: */, change_f);
!   life_analysis (f, nregs /* intel2: */, change_f);
    if (file)
      dump_flow_info (file);
  
+   /* intel1 */
+   if (flag_correct_cse_mistakes && change_f)
+     {
+       correct_cse_mistakes (f, nregs, file);
+     }
    basic_block_drops_in = 0;
    uid_block_number = 0;
    basic_block_loop_depth = 0;
***************
*** 400,407 ****
     NONLOCAL_LABEL_LIST is the same local variable from flow_analysis.  */
  
  static void
! find_basic_blocks (f, nonlocal_label_list)
       rtx f, nonlocal_label_list;
  {
    register rtx insn;
    register int i;
--- 428,436 ----
     NONLOCAL_LABEL_LIST is the same local variable from flow_analysis.  */
  
  static void
! find_basic_blocks (f, nonlocal_label_list /* intel2: */, change_f)
       rtx f, nonlocal_label_list;
+      int change_f;/* intel2 */
  {
    register rtx insn;
    register int i;
***************
*** 634,642 ****
  	 They can occur because jump_optimize does not recognize
  	 unreachable loops as unreachable.  */
  
!       deleted = 0;
        for (i = 0; i < n_basic_blocks; i++)
! 	if (!block_live[i])
  	  {
  	    deleted++;
  
--- 663,671 ----
  	 They can occur because jump_optimize does not recognize
  	 unreachable loops as unreachable.  */
  
!       deleted=0;
        for (i = 0; i < n_basic_blocks; i++)
! 	if (!block_live[i] /* intel2: */ && change_f)
  	  {
  	    deleted++;
  
***************
*** 874,882 ****
     regset_size and regset_bytes are also set here.  */
  
  static void
! life_analysis (f, nregs)
       rtx f;
       int nregs;
  {
    register regset tem;
    int first_pass;
--- 903,912 ----
     regset_size and regset_bytes are also set here.  */
  
  static void
! life_analysis (f, nregs /* intel2: */, change_f)
       rtx f;
       int nregs;
+      int change_f;	/* intel2 */
  {
    register regset tem;
    int first_pass;
***************
*** 904,911 ****
  
    max_regno = nregs;
  
-   bzero (regs_ever_live, sizeof regs_ever_live);
  
    /* Allocate and zero out many data structures
       that will record the data from lifetime analysis.  */
  
--- 934,947 ----
  
    max_regno = nregs;
  
  
+   /* intel2 - begin */
+   /* Dont reset the regs_ever_live array if called from memory_simplify */
+   if (change_f)
+     {
+       /* intel2 - end */
+       bzero (regs_ever_live, sizeof regs_ever_live);
+     }
    /* Allocate and zero out many data structures
       that will record the data from lifetime analysis.  */
  
***************
*** 950,959 ****
    for (insn = f; insn; insn = NEXT_INSN (insn))
      {
        enum rtx_code code1 = GET_CODE (insn);
!       if (code1 == CALL_INSN)
  	INSN_VOLATILE (insn) = 1;
        else if (code1 == INSN || code1 == JUMP_INSN)
  	{
  	  /* Delete (in effect) any obvious no-op moves.  */
  	  if (GET_CODE (PATTERN (insn)) == SET
  	      && GET_CODE (SET_DEST (PATTERN (insn))) == REG
--- 986,1017 ----
    for (insn = f; insn; insn = NEXT_INSN (insn))
      {
        enum rtx_code code1 = GET_CODE (insn);
!       if (code1 == CALL_INSN /* intel2: */ && change_f)
  	INSN_VOLATILE (insn) = 1;
        else if (code1 == INSN || code1 == JUMP_INSN)
  	{
+ 		/* intel2 - begin */
+ 		/* if change_f is reset, i.e. we are called from memory_simplify, and
+ 		 * therefore we would like to update the insn's REG_DEAD notes.
+ 		 * If we find a REG_DEAD note, we remove it here.
+ 		 */
+ 		if (!change_f)
+ 		{
+ 			register rtx note;
+ 			
+ 
+ 			for (note = REG_NOTES (insn); note; note = XEXP (note, 1))
+ 				if (REG_NOTE_KIND (note) == REG_DEAD
+ 				    || REG_NOTE_KIND (note) == REG_UNUSED)
+ 					remove_note(insn, note);
+ 		} 
+ 		/* intel2 - end */
+ 
+ 
+ /* intel2 - begin */
+ 		if (change_f)
+ 		{
+ /* intel2 - end */
  	  /* Delete (in effect) any obvious no-op moves.  */
  	  if (GET_CODE (PATTERN (insn)) == SET
  	      && GET_CODE (SET_DEST (PATTERN (insn))) == REG
***************
*** 1014,1019 ****
--- 1072,1080 ----
  #endif
  		   && XEXP (SET_SRC (PATTERN (insn)), 0) == stack_pointer_rtx)
  	    INSN_VOLATILE (insn) = 1;
+ 		/* intel2 - begin */
+ 		} /* if (change_f) */
+ 		/* intel2 - end */
  	}
      }
  
***************
*** 1154,1160 ****
  			       basic_block_head[i], basic_block_end[i], 0,
  			       first_pass ? basic_block_significant[i]
  			       : (regset) 0,
! 			       i);
  	    }
  
  	  {
--- 1215,1221 ----
  			       basic_block_head[i], basic_block_end[i], 0,
  			       first_pass ? basic_block_significant[i]
  			       : (regset) 0,
! 			       i/* intel2: */, change_f);
  	    }
  
  	  {
***************
*** 1219,1225 ****
      {
        propagate_block (basic_block_live_at_end[i],
  		       basic_block_head[i], basic_block_end[i], 1,
! 		       (regset) 0, i);
  #ifdef USE_C_ALLOCA
        alloca (0);
  #endif
--- 1280,1286 ----
      {
        propagate_block (basic_block_live_at_end[i],
  		       basic_block_head[i], basic_block_end[i], 1,
! 		       (regset) 0, i/* intel2: */, change_f);
  #ifdef USE_C_ALLOCA
        alloca (0);
  #endif
***************
*** 1316,1322 ****
     SPACE is of type regset, but it is really as long as NELTS regsets.
     BYTES_PER_ELT is the number of bytes in one regset.  */
  
! static void
  init_regset_vector (vector, space, nelts, bytes_per_elt)
       regset *vector;
       regset space;
--- 1377,1383 ----
     SPACE is of type regset, but it is really as long as NELTS regsets.
     BYTES_PER_ELT is the number of bytes in one regset.  */
  
! /* intel2 static */ void
  init_regset_vector (vector, space, nelts, bytes_per_elt)
       regset *vector;
       regset space;
***************
*** 1353,1365 ****
     BNUM is the number of the basic block.  */
  
  static void
! propagate_block (old, first, last, final, significant, bnum)
       register regset old;
       rtx first;
       rtx last;
       int final;
       regset significant;
!      int bnum;
  {
    register rtx insn;
    rtx prev;
--- 1414,1426 ----
     BNUM is the number of the basic block.  */
  
  static void
! propagate_block (old, first, last, final, significant, bnum /* intel2: */, change_f)
       register regset old;
       rtx first;
       rtx last;
       int final;
       regset significant;
!      int bnum /* intel2: */, change_f;
  {
    register rtx insn;
    rtx prev;
***************
*** 1403,1409 ****
  	loop_depth--;
      }
  
!   if (final)
      {
        register int i, offset;
        REGSET_ELT_TYPE bit;
--- 1464,1470 ----
  	loop_depth--;
      }
  
!   if (final /* intel2: */ && change_f)
      {
        register int i, offset;
        REGSET_ELT_TYPE bit;
***************
*** 1487,1493 ****
  	     "delete" it by turning it into a NOTE of type NOTE_INSN_DELETED.
  	     We could really delete it with delete_insn, but that
  	     can cause trouble for first or last insn in a basic block.  */
! 	  if (final && insn_is_dead)
  	    {
  	      PUT_CODE (insn, NOTE);
  	      NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
--- 1548,1554 ----
  	     "delete" it by turning it into a NOTE of type NOTE_INSN_DELETED.
  	     We could really delete it with delete_insn, but that
  	     can cause trouble for first or last insn in a basic block.  */
! 	  if (final /* intel2: */ && change_f && insn_is_dead)
  	    {
  	      PUT_CODE (insn, NOTE);
  	      NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
***************
*** 1529,1535 ****
  	  {
  	    register rtx x = PATTERN (insn);
  	    /* Does this instruction increment or decrement a register?  */
! 	    if (final && GET_CODE (x) == SET
  		&& GET_CODE (SET_DEST (x)) == REG
  		&& (GET_CODE (SET_SRC (x)) == PLUS
  		    || GET_CODE (SET_SRC (x)) == MINUS)
--- 1590,1596 ----
  	  {
  	    register rtx x = PATTERN (insn);
  	    /* Does this instruction increment or decrement a register?  */
! 	    if (final /* intel2: */ && change_f && GET_CODE (x) == SET
  		&& GET_CODE (SET_DEST (x)) == REG
  		&& (GET_CODE (SET_SRC (x)) == PLUS
  		    || GET_CODE (SET_SRC (x)) == MINUS)
***************
*** 1573,1579 ****
  		 live.  */
  
  	      mark_set_regs (old, dead, PATTERN (insn),
! 			     final ? insn : NULL_RTX, significant);
  
  	      /* If an insn doesn't use CC0, it becomes dead since we 
  		 assume that every insn clobbers it.  So show it dead here;
--- 1634,1640 ----
  		 live.  */
  
  	      mark_set_regs (old, dead, PATTERN (insn),
! 			     (final /* intel2: */ && change_f) ? insn : NULL_RTX, significant);
  
  	      /* If an insn doesn't use CC0, it becomes dead since we 
  		 assume that every insn clobbers it.  So show it dead here;
***************
*** 1637,1643 ****
  		  old[i] |= live[i];
  		}
  
! 	      if (GET_CODE (insn) == CALL_INSN && final)
  		{
  		  /* Any regs live at the time of a call instruction
  		     must not go in a register clobbered by calls.
--- 1698,1704 ----
  		  old[i] |= live[i];
  		}
  
! 	      if (GET_CODE (insn) == CALL_INSN && final /* intel2: */ && change_f)
  		{
  		  /* Any regs live at the time of a call instruction
  		     must not go in a register clobbered by calls.
***************
*** 1655,1661 ****
  	     into MAXLIVE and REGS_SOMETIMES_LIVE.
  	     Also update counts of how many insns each reg is live at.  */
  
! 	  if (final)
  	    {
  	      for (i = 0; i < regset_size; i++)
  		{
--- 1716,1722 ----
  	     into MAXLIVE and REGS_SOMETIMES_LIVE.
  	     Also update counts of how many insns each reg is live at.  */
  
! 	  if (final /* intel2: */ && change_f)
  	    {
  	      for (i = 0; i < regset_size; i++)
  		{
***************
*** 2878,2883 ****
--- 2939,2949 ----
  {
    register int i;
    static char *reg_class_names[] = REG_CLASS_NAMES;
+   /* intel1 */
+ #ifdef SPARE_REGS
+   int max_regno;
+   max_regno = max_reg_num();
+ #endif
  
    fprintf (file, "%d registers.\n", max_regno);
  
